/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-20 at 19:34:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.adexchangebuyer.model;

/**
 * A creative and its classification data.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ad Exchange Buyer API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Creative extends com.google.api.client.json.GenericJson {

  /**
   * The HTML snippet that displays the ad when inserted in the web page. If set, videoURL should
   * not be set.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("HTMLSnippet")
  private java.lang.String hTMLSnippet;

  /**
   * Account id.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer accountId;

  /**
   * Detected advertiser id, if any. Read-only. This field should not be set in requests.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.util.List<java.lang.Long> advertiserId;

  /**
   * The name of the company being advertised in the creative.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String advertiserName;

  /**
   * The agency id for this creative.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long agencyId;

  /**
   * All attributes for the ads that may be shown from this snippet.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.Integer> attribute;

  /**
   * A buyer-specific id identifying the creative in this ad.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String buyerCreativeId;

  /**
   * The set of destination urls for the snippet.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> clickThroughUrl;

  /**
   * The reasons for disapproval, if any. Note that not all disapproval reasons may be categorized,
   * so it is possible for the creative to have a status of DISAPPROVED with an empty list for
   * disapproval_reasons. In this case, please reach out to your TAM to help debug the issue. Read-
   * only. This field should not be set in requests.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<DisapprovalReasons> disapprovalReasons;

  static {
    // hack to force ProGuard to consider DisapprovalReasons used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(DisapprovalReasons.class);
  }

  /**
   * Ad height.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer height;

  /**
   * Resource type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Detected product categories, if any. Read-only. This field should not be set in requests.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.Integer> productCategories;

  /**
   * Detected sensitive categories, if any. Read-only. This field should not be set in requests.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.Integer> sensitiveCategories;

  /**
   * Creative serving status. Read-only. This field should not be set in requests.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * All vendor types for the ads that may be shown from this snippet.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.Integer> vendorType;

  /**
   * The url to fetch a video ad. If set, HTMLSnippet should not be set.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String videoURL;

  /**
   * Ad width.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer width;

  /**
   * The HTML snippet that displays the ad when inserted in the web page. If set, videoURL should
   * not be set.
   * @return value or {@code null} for none
   */
  public java.lang.String getHTMLSnippet() {
    return hTMLSnippet;
  }

  /**
   * The HTML snippet that displays the ad when inserted in the web page. If set, videoURL should
   * not be set.
   * @param hTMLSnippet hTMLSnippet or {@code null} for none
   */
  public Creative setHTMLSnippet(java.lang.String hTMLSnippet) {
    this.hTMLSnippet = hTMLSnippet;
    return this;
  }

  /**
   * Account id.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getAccountId() {
    return accountId;
  }

  /**
   * Account id.
   * @param accountId accountId or {@code null} for none
   */
  public Creative setAccountId(java.lang.Integer accountId) {
    this.accountId = accountId;
    return this;
  }

  /**
   * Detected advertiser id, if any. Read-only. This field should not be set in requests.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Long> getAdvertiserId() {
    return advertiserId;
  }

  /**
   * Detected advertiser id, if any. Read-only. This field should not be set in requests.
   * @param advertiserId advertiserId or {@code null} for none
   */
  public Creative setAdvertiserId(java.util.List<java.lang.Long> advertiserId) {
    this.advertiserId = advertiserId;
    return this;
  }

  /**
   * The name of the company being advertised in the creative.
   * @return value or {@code null} for none
   */
  public java.lang.String getAdvertiserName() {
    return advertiserName;
  }

  /**
   * The name of the company being advertised in the creative.
   * @param advertiserName advertiserName or {@code null} for none
   */
  public Creative setAdvertiserName(java.lang.String advertiserName) {
    this.advertiserName = advertiserName;
    return this;
  }

  /**
   * The agency id for this creative.
   * @return value or {@code null} for none
   */
  public java.lang.Long getAgencyId() {
    return agencyId;
  }

  /**
   * The agency id for this creative.
   * @param agencyId agencyId or {@code null} for none
   */
  public Creative setAgencyId(java.lang.Long agencyId) {
    this.agencyId = agencyId;
    return this;
  }

  /**
   * All attributes for the ads that may be shown from this snippet.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Integer> getAttribute() {
    return attribute;
  }

  /**
   * All attributes for the ads that may be shown from this snippet.
   * @param attribute attribute or {@code null} for none
   */
  public Creative setAttribute(java.util.List<java.lang.Integer> attribute) {
    this.attribute = attribute;
    return this;
  }

  /**
   * A buyer-specific id identifying the creative in this ad.
   * @return value or {@code null} for none
   */
  public java.lang.String getBuyerCreativeId() {
    return buyerCreativeId;
  }

  /**
   * A buyer-specific id identifying the creative in this ad.
   * @param buyerCreativeId buyerCreativeId or {@code null} for none
   */
  public Creative setBuyerCreativeId(java.lang.String buyerCreativeId) {
    this.buyerCreativeId = buyerCreativeId;
    return this;
  }

  /**
   * The set of destination urls for the snippet.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getClickThroughUrl() {
    return clickThroughUrl;
  }

  /**
   * The set of destination urls for the snippet.
   * @param clickThroughUrl clickThroughUrl or {@code null} for none
   */
  public Creative setClickThroughUrl(java.util.List<java.lang.String> clickThroughUrl) {
    this.clickThroughUrl = clickThroughUrl;
    return this;
  }

  /**
   * The reasons for disapproval, if any. Note that not all disapproval reasons may be categorized,
   * so it is possible for the creative to have a status of DISAPPROVED with an empty list for
   * disapproval_reasons. In this case, please reach out to your TAM to help debug the issue. Read-
   * only. This field should not be set in requests.
   * @return value or {@code null} for none
   */
  public java.util.List<DisapprovalReasons> getDisapprovalReasons() {
    return disapprovalReasons;
  }

  /**
   * The reasons for disapproval, if any. Note that not all disapproval reasons may be categorized,
   * so it is possible for the creative to have a status of DISAPPROVED with an empty list for
   * disapproval_reasons. In this case, please reach out to your TAM to help debug the issue. Read-
   * only. This field should not be set in requests.
   * @param disapprovalReasons disapprovalReasons or {@code null} for none
   */
  public Creative setDisapprovalReasons(java.util.List<DisapprovalReasons> disapprovalReasons) {
    this.disapprovalReasons = disapprovalReasons;
    return this;
  }

  /**
   * Ad height.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getHeight() {
    return height;
  }

  /**
   * Ad height.
   * @param height height or {@code null} for none
   */
  public Creative setHeight(java.lang.Integer height) {
    this.height = height;
    return this;
  }

  /**
   * Resource type.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Resource type.
   * @param kind kind or {@code null} for none
   */
  public Creative setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Detected product categories, if any. Read-only. This field should not be set in requests.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Integer> getProductCategories() {
    return productCategories;
  }

  /**
   * Detected product categories, if any. Read-only. This field should not be set in requests.
   * @param productCategories productCategories or {@code null} for none
   */
  public Creative setProductCategories(java.util.List<java.lang.Integer> productCategories) {
    this.productCategories = productCategories;
    return this;
  }

  /**
   * Detected sensitive categories, if any. Read-only. This field should not be set in requests.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Integer> getSensitiveCategories() {
    return sensitiveCategories;
  }

  /**
   * Detected sensitive categories, if any. Read-only. This field should not be set in requests.
   * @param sensitiveCategories sensitiveCategories or {@code null} for none
   */
  public Creative setSensitiveCategories(java.util.List<java.lang.Integer> sensitiveCategories) {
    this.sensitiveCategories = sensitiveCategories;
    return this;
  }

  /**
   * Creative serving status. Read-only. This field should not be set in requests.
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * Creative serving status. Read-only. This field should not be set in requests.
   * @param status status or {@code null} for none
   */
  public Creative setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  /**
   * All vendor types for the ads that may be shown from this snippet.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Integer> getVendorType() {
    return vendorType;
  }

  /**
   * All vendor types for the ads that may be shown from this snippet.
   * @param vendorType vendorType or {@code null} for none
   */
  public Creative setVendorType(java.util.List<java.lang.Integer> vendorType) {
    this.vendorType = vendorType;
    return this;
  }

  /**
   * The url to fetch a video ad. If set, HTMLSnippet should not be set.
   * @return value or {@code null} for none
   */
  public java.lang.String getVideoURL() {
    return videoURL;
  }

  /**
   * The url to fetch a video ad. If set, HTMLSnippet should not be set.
   * @param videoURL videoURL or {@code null} for none
   */
  public Creative setVideoURL(java.lang.String videoURL) {
    this.videoURL = videoURL;
    return this;
  }

  /**
   * Ad width.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getWidth() {
    return width;
  }

  /**
   * Ad width.
   * @param width width or {@code null} for none
   */
  public Creative setWidth(java.lang.Integer width) {
    this.width = width;
    return this;
  }

  @Override
  public Creative set(String fieldName, Object value) {
    return (Creative) super.set(fieldName, value);
  }

  @Override
  public Creative clone() {
    return (Creative) super.clone();
  }

  /**
   * Model definition for CreativeDisapprovalReasons.
   */
  public static final class DisapprovalReasons extends com.google.api.client.json.GenericJson {

    /**
     * Additional details about the reason for disapproval.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<java.lang.String> details;

    /**
     * The categorized reason for disapproval.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String reason;

    /**
     * Additional details about the reason for disapproval.
     * @return value or {@code null} for none
     */
    public java.util.List<java.lang.String> getDetails() {
      return details;
    }

    /**
     * Additional details about the reason for disapproval.
     * @param details details or {@code null} for none
     */
    public DisapprovalReasons setDetails(java.util.List<java.lang.String> details) {
      this.details = details;
      return this;
    }

    /**
     * The categorized reason for disapproval.
     * @return value or {@code null} for none
     */
    public java.lang.String getReason() {
      return reason;
    }

    /**
     * The categorized reason for disapproval.
     * @param reason reason or {@code null} for none
     */
    public DisapprovalReasons setReason(java.lang.String reason) {
      this.reason = reason;
      return this;
    }

    @Override
    public DisapprovalReasons set(String fieldName, Object value) {
      return (DisapprovalReasons) super.set(fieldName, value);
    }

    @Override
    public DisapprovalReasons clone() {
      return (DisapprovalReasons) super.clone();
    }

  }

}
